ARG CI_REGISTRY_IMAGE="registry.gitlab.com/gitlab-org/build/cng"
ARG TAG="master"
ARG FROM_IMAGE="$CI_REGISTRY_IMAGE/gitlab-ruby"
ARG PG_VERSION="16.4"
ARG PG_IMAGE="$CI_REGISTRY_IMAGE/postgresql:${PG_VERSION}"
ARG GM_IMAGE="$CI_REGISTRY_IMAGE/gitlab-graphicsmagick:${GM_VERSION}"
ARG EXIFTOOL_IMAGE="$CI_REGISTRY_IMAGE/gitlab-exiftool:${EXIFTOOL_VERSION}"
ARG GEI_IMAGE="$CI_REGISTRY_IMAGE/gitlab-elasticsearch-indexer:1.0.0"
ARG GITLAB_VERSION=v10.7.0-ee
ARG ASSETS_IMAGE="registry.gitlab.com/gitlab-org/gitlab-ee/gitlab-assets-ee:${GITLAB_VERSION}"
ARG RUST_TAG="master"

# https://docs.docker.com/engine/reference/builder/#understand-how-arg-and-from-interact
<% if !compile_assets %>
FROM --platform=$TARGETPLATFORM ${ASSETS_IMAGE} as assets
<% end %>
FROM --platform=$TARGETPLATFORM ${PG_IMAGE} as pg_image
FROM --platform=$TARGETPLATFORM ${GM_IMAGE} as graphicsmagick_image
FROM --platform=$TARGETPLATFORM ${EXIFTOOL_IMAGE} as exiftool_image
<% if ee? %>
FROM --platform=$TARGETPLATFORM ${GEI_IMAGE} as gei_image
<% end %>

FROM --platform=$TARGETPLATFORM ${CI_REGISTRY_IMAGE}/gitlab-rust:${RUST_TAG} AS gitlab-rust
FROM --platform=$TARGETPLATFORM ${FROM_IMAGE}:${TAG} as base

COPY --from=gitlab-rust /assets /

ARG BUILD_DIR=/tmp/build
ARG DATADIR=/var/opt/gitlab
ARG CPU_COUNT=4
ARG GITLAB_USER=git
ARG COMPILE_ASSETS_ENV="RAILS_ENV=production NODE_ENV=production USE_DB=false SKIP_STORAGE_VALIDATION=true"
ARG NODE_VERSION=20.12.2
ARG RUBY_VERSION=3.2.5
ARG YARN_VERSION=1.22.18
ARG TARGETARCH
ARG ARCH

FROM --platform=$TARGETPLATFORM base as base-amd64
ARG ARCH=x64

FROM --platform=$TARGETPLATFORM base as base-arm64
ARG ARCH=arm64

FROM --platform=$TARGETPLATFORM base-$TARGETARCH as builder-base
# install runtime deps
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=866729
RUN mkdir -p /usr/share/man/man7 \
    && apt-get update \
    && apt-get install -y --no-install-recommends libicu72 tzdata \
    && rm -rf /var/lib/apt/lists/*

# Include postgres client tools
COPY --from=pg_image /usr/local/psql/bin/ /usr/bin/
COPY --from=pg_image /usr/local/psql/lib/ /usr/lib/
COPY --from=pg_image /usr/local/psql/include/ /usr/include/

# Include GraphicsMagick (bin,include,lib,share)
COPY --from=graphicsmagick_image /usr/local/ /usr/local/

COPY shared/build-scripts/ /build-scripts

RUN buildDeps=' \
    make \
    clang \
    cmake \
    gcc \
    g++ \
    libclang-dev \
    libicu-dev \
    libffi-dev \
    llvm-dev \
    musl-dev \
    patch \
    pkg-config \
    libkrb5-3 \
    libkrb5-dev \
    git \
    sudo' \
    && apt-get update \
    && DEBIAN_FRONTEND=noninteractive apt-get install -y --no-install-recommends $buildDeps \
    && rm -rf /var/lib/apt/lists/* \
    && mkdir -p ${BUILD_DIR}

RUN NODE_TARBALL="node-v${NODE_VERSION}-linux-${ARCH}.tar.gz" ; \
    /build-scripts/curl_retry_netfail "https://nodejs.org/download/release/v${NODE_VERSION}/${NODE_TARBALL}" ${NODE_TARBALL} \
    && tar --strip-components 1 -xzC /usr/local/ -f ${NODE_TARBALL}

RUN mkdir /usr/local/yarn ; YARN_TARBALL="yarn-v${YARN_VERSION}.tar.gz" ; \
    /build-scripts/curl_retry_netfail "https://yarnpkg.com/downloads/${YARN_VERSION}/${YARN_TARBALL}" ${YARN_TARBALL} \
    && tar --strip-components 1 -xzC /usr/local/yarn -f ${YARN_TARBALL} \
    && ln -sf /usr/local/yarn/bin/yarn /usr/local/bin/ \
    && ln -sf /usr/local/yarn/bin/yarnpkg /usr/local/bin/

# create gitlab user
RUN adduser --disabled-password --gecos 'GitLab' ${GITLAB_USER}

# $DATADIR is the main mountpoint for gitlab data volume
RUN mkdir ${DATADIR} && \
    cd ${DATADIR} && \
    mkdir data repo config && \
    chown -R ${GITLAB_USER}:${GITLAB_USER} ${DATADIR}

# Install node_modules in separate stage to not invalidate cache of next steps when it changes
# Also speeds up the build by installing node dependencies and gems in parallel
FROM builder-base AS node-deps

ARG CACHE_BUSTER=false

COPY --chown=${GITLAB_USER}:${GITLAB_USER} gitlab-code/package.json gitlab-code/yarn.lock /srv/gitlab/
COPY --chown=${GITLAB_USER}:${GITLAB_USER} gitlab-code/scripts/frontend/preinstall.mjs gitlab-code/scripts/frontend/postinstall.js /srv/gitlab/scripts/frontend/
RUN cd /srv/gitlab && \
    sudo -u ${GITLAB_USER} -H $COMPILE_ASSETS_ENV yarn install --production --pure-lockfile

FROM builder-base as builder

ARG CACHE_BUSTER=false

<% if compile_assets and gitlab_bundle_gemfile %>
# If gitlab_bundle_gemfile is set, copy all of the code for it to work correctly because Gemfile will be in non default location
COPY --chown=git gitlab-code/ /srv/gitlab/
COPY --chown=git vendor/bundle/${TARGETARCH} /srv/gitlab/vendor/bundle
RUN cd /srv/gitlab && \
    mkdir -p vendor/bundle && \
    sudo -u git -H bundle config set --local gemfile <%= gitlab_bundle_gemfile %> && \
    sudo -u git -H bundle config set --local path /srv/gitlab/vendor/bundle/
<% else %>
# Only copy relevant files first, this allows to cache the layer separately and not re-install gems on non dependency changes
COPY --chown=git gitlab-code/Gemfile gitlab-code/Gemfile.lock gitlab-code/Gemfile.checksum /srv/gitlab/
COPY --chown=git gitlab-code/Gemfile gitlab-code/vendor/gems/ /srv/gitlab/vendor/gems/
COPY --chown=git gitlab-code/Gemfile gitlab-code/gems/ /srv/gitlab/gems/
<% end %>

RUN cd /srv/gitlab && \
    sudo -u git -H bundle config set --local version system && \
    sudo -u git -H bundle config set --local clean 'true' && \
    sudo -u git -H bundle config set --local deployment 'true' && \
    sudo -u git -H bundle config set --local without 'development test mysql aws' && \
    sudo -u git -H bundle install --jobs 4 --retry 5

# Configure GitLab
COPY --chown=${GITLAB_USER}:${GITLAB_USER} gitlab-code/ /srv/gitlab/
RUN cd /srv/gitlab && \
    sudo -u ${GITLAB_USER} -H mkdir ${DATADIR}/.upgrade-status && \
    sudo -u ${GITLAB_USER} -H echo 'gitlab-cloud-native-image' > INSTALLATION_TYPE && \
    sudo -u ${GITLAB_USER} -H cp config/gitlab.yml.example config/gitlab.yml && \
    sudo -u ${GITLAB_USER} -H cp config/resque.yml.example config/resque.yml && \
    sudo -u ${GITLAB_USER} -H cp config/secrets.yml.example config/secrets.yml && \
    sudo -u ${GITLAB_USER} -H cp config/database.yml.postgresql config/database.yml && \
    sed --in-place "/host: localhost/d" config/gitlab.yml && \
<% unless ee? -%>
    sed --in-place "/geo:/,/^$/d" config/database.yml && \
<% end -%>
    sed --in-place "/port: 80/d" config/gitlab.yml && \
    sed --in-place "s/# user:.*/user: ${GITLAB_USER}/" config/gitlab.yml && \
    sed --in-place "s:/home/git/repositories:${DATADIR}/repo:" config/gitlab.yml && \
    cp --remove-destination /srv/gitlab/VERSION /srv/gitlab/workhorse/VERSION

# compile GetText PO files
COPY --from=node-deps /srv/gitlab/node_modules /srv/gitlab/node_modules
RUN cd /srv/gitlab && \
    sudo -u ${GITLAB_USER} -H $COMPILE_ASSETS_ENV bundle exec rake gettext:compile

<% if compile_assets %>
# compile assets
RUN cd /srv/gitlab && \
    sudo -u ${GITLAB_USER} -H $COMPILE_ASSETS_ENV bundle exec rake gitlab:assets:compile
<% end %>

# Clean up
RUN cd /srv/gitlab && \
    rm -rf node_modules/ tmp/ spec/ ee/spec/ && \
    rm -rf qa/ rubocop/ tooling/ .gitlab/ .github/ docker/ && \
    rm -rf changelogs/ danger/ Dangerfile && \
    RUBY_VERSION=${RUBY_VERSION} /build-scripts/cleanup-gems

# Set the path that bootsnap will use for cache
ENV BOOTSNAP_CACHE_DIR=/srv/gitlab/bootsnap
ENV ENABLE_BOOTSNAP=1

# Generate bootsnap cache
RUN echo "Generating bootsnap cache"; \
    cd /srv/gitlab && \
    sudo -u ${GITLAB_USER} mkdir ${BOOTSNAP_CACHE_DIR} && \
    sudo -u ${GITLAB_USER} -H $COMPILE_ASSETS_ENV -E \
         bundle exec bootsnap precompile --gemfile --exclude '/srv/gitlab/config/*.yml|/srv/gitlab/public' . && \
    du -hs ${BOOTSNAP_CACHE_DIR} ;
# exit code of this command will be that of `du`

<% if !compile_assets %>
# install assets from assets container (see ARG ASSETS_IMAGE at top)
COPY --chown=git --from=assets assets /srv/gitlab/public/assets/
<% end %>

# remove uncompressed maps as per #2062
RUN find /srv/gitlab/public/assets/webpack -name '*.map' -type f -print -delete

## FINAL IMAGE ##

FROM --platform=$TARGETPLATFORM "$CI_REGISTRY_IMAGE/gitlab-ruby:${TAG}"
ARG DATADIR=/var/opt/gitlab
ARG CONFIG=/srv/gitlab/config
ARG GITLAB_USER=git

# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=866729
RUN mkdir -p /usr/share/man/man7 \
    && apt-get update \
    && apt-get install -q -y --no-install-recommends \
         libicu72 tzdata xtail \
         libpng16-16 libtiff6 libturbojpeg0 zlib1g \
         # required for exiftool
         perl \
         # required for diagnostic report compression
         gzip \
    && rm -rf /var/lib/apt/lists/*

<% if ee? %>
# Include the gitlab-elasticsearch-indexer
COPY --from=gei_image /usr/local/bin/gitlab-elasticsearch-indexer /usr/bin/
<% end %>

# Include postgres client tools
COPY --from=pg_image /usr/local/psql/bin/pg_* /usr/bin/
COPY --from=pg_image /usr/local/psql/bin/psql /usr/bin/
COPY --from=pg_image /usr/local/psql/lib/libpq.so* /usr/lib/

# Include GraphicsMagick (binary and license)
COPY --from=graphicsmagick_image /usr/local /usr/local

# Include of exiftool
COPY --from=exiftool_image / /

RUN buildDeps=' \
    libicu-dev \
    libffi-dev \
    libedit-dev \
    libxml2-dev \
    sudo' \
    && apt-get update \
    && apt-get install -y --no-install-recommends $buildDeps \
    && rm -rf /var/lib/apt/lists/*

RUN adduser --disabled-password --gecos 'GitLab' ${GITLAB_USER}

COPY --chown=git --from=builder /srv/gitlab /srv/gitlab
COPY --chown=git --from=builder /var/opt/gitlab /var/opt/gitlab

RUN mv /srv/gitlab/log /var/log/gitlab && \
    ln -s /var/log/gitlab /srv/gitlab/log && \
    cd /srv/gitlab && \
    chmod o-rwx config/database.yml && \
    chmod 0600 config/secrets.yml && \
    chmod -R u+rwX builds/ && \
    chmod -R u+rwX shared/artifacts/ && \
    chmod -R ug+rwX shared/pages/ && \
    chmod -R ug+rwX,o-rwx ${DATADIR}/repo && \
    chmod -R ug-s ${DATADIR}/repo && \
    find ${DATADIR}/repo -type d -print0 | sudo xargs -0 chmod g+s && \
    mkdir -p public/uploads && chown ${GITLAB_USER}:${GITLAB_USER} public/uploads && \
    chmod 0700 public/uploads && \
    mkdir /home/git/gitlab-shell && \
    chown git:git /home/git/gitlab-shell && \
    ln -s /srv/gitlab/GITLAB_SHELL_VERSION /home/git/gitlab-shell/VERSION

COPY --chown=${GITLAB_USER} scripts/ /scripts

ENV RAILS_ENV=production \
    BOOTSNAP_CACHE_DIR=/srv/gitlab/bootsnap \
    RUBYOPT="-W:no-experimental" \
    EXECJS_RUNTIME=Disabled \
    CONFIG_TEMPLATE_DIRECTORY=${CONFIG} \
    UPGRADE_STATUS_DIR=${DATADIR}/.upgrade-status

VOLUME /var/opt/gitlab /var/log
